diff -ruN vdr-1.3.37/device.h vdr-1.3.38/device.h
--- vdr-1.3.37/device.h	2005-11-05 16:25:41.000000000 +0100
+++ vdr-1.3.38/device.h	2006-01-08 11:10:26.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.h 1.66 2005/11/05 15:25:41 kls Exp $
+ * $Id: device.h 1.70 2006/01/08 10:10:26 kls Exp $
  */
 
 #ifndef __DEVICE_H
@@ -170,14 +170,16 @@
          ///< Returns the card index of this device (0 ... MAXDEVICES - 1).
   int DeviceNumber(void) const;
          ///< Returns the number of this device (0 ... MAXDEVICES - 1).
-  virtual int ProvidesCa(const cChannel *Channel) const;//XXX PLUGINS.html!!!
-         //XXX describe changed functionality!!!
-         ///< Checks whether this device provides the given value in its
-         ///< caCaps. Returns 0 if the value is not provided, 1 if only this
-         ///< value is provided, and > 1 if this and other values are provided.
-         ///< If the given value is equal to the number of this device,
-         ///< 1 is returned. If it is 0 (FTA), 1 plus the number of other values
-         ///< in caCaps is returned.
+  virtual int ProvidesCa(const cChannel *Channel) const;
+         ///< Checks whether this device provides the conditional access
+         ///< facilities to decrypt the given Channel.
+         ///< Returns 0 if the Channel can't be decrypted, 1 if this is a
+         ///< Free To Air channel or only exactly this device can decrypt it,
+         ///< and > 1 if this device can decrypt the Channel.
+         ///< If the result is greater than 1 and the device has more than one
+         ///< CAM, the value will be increased by the number of CAMs, which
+         ///< allows to select the device with the smallest number of CAMs
+         ///< in order to preserve resources for other recordings.
   virtual bool HasDecoder(void) const;
          ///< Tells whether this device has an MPEG decoder.
 
@@ -305,11 +307,9 @@
 // Image Grab facilities
 
 public:
-  virtual bool GrabImage(const char *FileName, bool Jpeg = true, int Quality = -1, int SizeX = -1, int SizeY = -1);
-         ///< Capture a single frame as an image.
-         ///< Grabs the currently visible screen image into the given file, with the
-         ///< given parameters.
-         ///< \param FileName The name of the file to write. Should include the proper extension.
+  virtual uchar *GrabImage(int &Size, bool Jpeg = true, int Quality = -1, int SizeX = -1, int SizeY = -1);
+         ///< Grabs the currently visible screen image.
+         ///< \param Size The size of the returned data block.
          ///< \param Jpeg If true will write a JPEG file. Otherwise a PNM file will be written.
          ///< \param Quality The compression factor for JPEG. 1 will create a very blocky
          ///<        and small image, 70..80 will yield reasonable quality images while keeping the
@@ -317,7 +317,13 @@
          ///<        but very high quality image.
          ///< \param SizeX The number of horizontal pixels in the frame (default is the current screen width).
          ///< \param SizeY The number of vertical pixels in the frame (default is the current screen height).
-         ///< \return True if all went well. */
+         ///< \return A pointer to the grabbed image data, or NULL in case of an error.
+         ///< The caller takes ownership of the returned memory and must free() it once it isn't needed any more.
+  bool GrabImageFile(const char *FileName, bool Jpeg = true, int Quality = -1, int SizeX = -1, int SizeY = -1);
+         ///< Calls GrabImage() and stores the resulting image in a file with the given name.
+         ///< \return True if all went well.
+         ///< The caller is responsible for making sure that the given file name
+         ///< doesn't lead to overwriting any important other file.
 
 // Video format facilities
 
@@ -338,6 +344,7 @@
 private:
   tTrackId availableTracks[ttMaxTrackTypes];
   eTrackType currentAudioTrack;
+  cMutex mutexCurrentAudioTrack;
   int currentAudioTrackMissingCount;
   bool pre_1_3_19_PrivateStream;
 protected:
@@ -516,6 +523,8 @@
        ///< Detaches the given receiver from this device.
   void DetachAll(int Pid);
        ///< Detaches all receivers from this device for this pid.
+  void DetachAllReceivers(void);
+       ///< Detaches all receivers from this device.
   };
 
 /// Derived cDevice classes that can receive channels will have to provide
diff -ruN vdr-1.3.37/diseqc.c vdr-1.3.38/diseqc.c
--- vdr-1.3.37/diseqc.c	2005-01-09 14:05:11.000000000 +0100
+++ vdr-1.3.38/diseqc.c	2005-12-30 16:41:48.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: diseqc.c 1.4 2005/01/09 13:05:11 kls Exp $
+ * $Id: diseqc.c 1.5 2005/12/30 15:41:48 kls Exp $
  */
 
 #include "diseqc.h"
@@ -65,7 +65,7 @@
         cCondWait::SleepMs(n);
      return p;
      }
-  esyslog("ERROR: illegal value for wait time in '%s'", s - 1);
+  esyslog("ERROR: invalid value for wait time in '%s'", s - 1);
   return NULL;
 }
 
@@ -85,7 +85,7 @@
                  t = skipspace(p);
                  }
               else {
-                 esyslog("ERROR: illegal code at '%s'", t);
+                 esyslog("ERROR: invalid code at '%s'", t);
                  return NULL;
                  }
               }
diff -ruN vdr-1.3.37/dvbdevice.c vdr-1.3.38/dvbdevice.c
--- vdr-1.3.37/dvbdevice.c	2005-11-26 14:23:11.000000000 +0100
+++ vdr-1.3.38/dvbdevice.c	2006-01-07 16:15:01.000000000 +0100
@@ -4,18 +4,11 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.c 1.138 2005/11/26 13:23:11 kls Exp $
+ * $Id: dvbdevice.c 1.149 2006/01/07 15:15:01 kls Exp $
  */
 
 #include "dvbdevice.h"
 #include <errno.h>
-extern "C" {
-#ifdef boolean
-#define HAVE_BOOLEAN
-#endif
-#include <jpeglib.h>
-#undef boolean
-}
 #include <limits.h>
 #include <linux/videodev.h>
 #include <linux/dvb/audio.h>
@@ -47,6 +40,13 @@
 #define DEV_DVB_AUDIO     "audio"
 #define DEV_DVB_CA        "ca"
 
+#define DVBS_TUNE_TIMEOUT  2000 //ms
+#define DVBS_LOCK_TIMEOUT  2000 //ms
+#define DVBC_TUNE_TIMEOUT  5000 //ms
+#define DVBC_LOCK_TIMEOUT  2000 //ms
+#define DVBT_TUNE_TIMEOUT  9000 //ms
+#define DVBT_LOCK_TIMEOUT  2000 //ms
+
 class cDvbName {
 private:
   char buffer[PATH_MAX];
@@ -73,6 +73,9 @@
   enum eTunerStatus { tsIdle, tsSet, tsTuned, tsLocked };
   int fd_frontend;
   int cardIndex;
+  int tuneTimeout;
+  int lockTimeout;
+  time_t lastTimeoutReport;
   fe_type_t frontendType;
   cCiHandler *ciHandler;
   cChannel channel;
@@ -81,7 +84,7 @@
   cMutex mutex;
   cCondVar locked;
   cCondVar newSet;
-  bool GetFrontendEvent(dvb_frontend_event &Event, int TimeoutMs = 0);
+  bool GetFrontendStatus(fe_status_t &Status, int TimeoutMs = 0);
   bool SetFrontend(void);
   virtual void Action(void);
 public:
@@ -98,6 +101,9 @@
   cardIndex = CardIndex;
   frontendType = FrontendType;
   ciHandler = CiHandler;
+  tuneTimeout = 0;
+  lockTimeout = 0;
+  lastTimeoutReport = 0;
   diseqcCommands = NULL;
   tunerStatus = tsIdle;
   if (frontendType == FE_QPSK)
@@ -125,6 +131,7 @@
   if (Tune)
      tunerStatus = tsSet;
   channel = *Channel;
+  lastTimeoutReport = 0;
   newSet.Broadcast();
 }
 
@@ -140,26 +147,18 @@
   return tunerStatus >= tsLocked;
 }
 
-bool cDvbTuner::GetFrontendEvent(dvb_frontend_event &Event, int TimeoutMs)
+bool cDvbTuner::GetFrontendStatus(fe_status_t &Status, int TimeoutMs)
 {
   if (TimeoutMs) {
-     struct pollfd pfd;
-     pfd.fd = fd_frontend;
-     pfd.events = POLLIN | POLLPRI;
-     do {
-        int stat = poll(&pfd, 1, TimeoutMs);
-        if (stat == 1)
-           break;
-        if (stat < 0) {
-           if (errno == EINTR)
-              continue;
-           esyslog("ERROR: frontend %d poll failed: %m", cardIndex);
-           }
-        return false;
-        } while (0);
+     cPoller Poller(fd_frontend);
+     if (Poller.Poll(TimeoutMs)) {
+        dvb_frontend_event Event;
+        while (ioctl(fd_frontend, FE_GET_EVENT, &Event) == 0)
+              ; // just to clear the event queue - we'll read the actual status below
+        }
      }
   do {
-     int stat = ioctl(fd_frontend, FE_GET_EVENT, &Event);
+     int stat = ioctl(fd_frontend, FE_READ_STATUS, &Status);
      if (stat == 0)
         return true;
      if (stat < 0) {
@@ -245,6 +244,9 @@
          Frontend.inversion = fe_spectral_inversion_t(channel.Inversion());
          Frontend.u.qpsk.symbol_rate = channel.Srate() * 1000UL;
          Frontend.u.qpsk.fec_inner = fe_code_rate_t(channel.CoderateH());
+
+         tuneTimeout = DVBS_TUNE_TIMEOUT;
+         lockTimeout = DVBS_LOCK_TIMEOUT;
          }
          break;
     case FE_QAM: { // DVB-C
@@ -256,6 +258,9 @@
          Frontend.u.qam.symbol_rate = channel.Srate() * 1000UL;
          Frontend.u.qam.fec_inner = fe_code_rate_t(channel.CoderateH());
          Frontend.u.qam.modulation = fe_modulation_t(channel.Modulation());
+
+         tuneTimeout = DVBC_TUNE_TIMEOUT;
+         lockTimeout = DVBC_LOCK_TIMEOUT;
          }
          break;
     case FE_OFDM: { // DVB-T
@@ -271,6 +276,9 @@
          Frontend.u.ofdm.transmission_mode = fe_transmit_mode_t(channel.Transmission());
          Frontend.u.ofdm.guard_interval = fe_guard_interval_t(channel.Guard());
          Frontend.u.ofdm.hierarchy_information = fe_hierarchy_t(channel.Hierarchy());
+
+         tuneTimeout = DVBT_TUNE_TIMEOUT;
+         lockTimeout = DVBT_LOCK_TIMEOUT;
          }
          break;
     default:
@@ -286,30 +294,54 @@
 
 void cDvbTuner::Action(void)
 {
-  dvb_frontend_event event;
+  cTimeMs Timer;
+  bool LostLock = false;
+  fe_status_t Status = (fe_status_t)0;
   while (Running()) {
-        bool hasEvent = GetFrontendEvent(event, 1);
-
+        fe_status_t NewStatus;
+        if (GetFrontendStatus(NewStatus, 10))
+           Status = NewStatus;
         cMutexLock MutexLock(&mutex);
         switch (tunerStatus) {
           case tsIdle:
                break;
           case tsSet:
-               if (hasEvent)
-                  continue;
                tunerStatus = SetFrontend() ? tsTuned : tsIdle;
+               Timer.Set(tuneTimeout);
                continue;
           case tsTuned:
-          case tsLocked:
-               if (hasEvent) {
-                  if (event.status & FE_REINIT) {
-                     tunerStatus = tsSet;
-                     esyslog("ERROR: frontend %d was reinitialized - re-tuning", cardIndex);
+               if (Timer.TimedOut()) {
+                  tunerStatus = tsSet;
+                  diseqcCommands = NULL;
+                  if (time(NULL) - lastTimeoutReport > 60) { // let's not get too many of these
+                     esyslog("ERROR: frontend %d timed out while tuning to channel %d, tp %d", cardIndex, channel.Number(), channel.Transponder());
+                     lastTimeoutReport = time(NULL);
                      }
-                  if (event.status & FE_HAS_LOCK) {
-                     tunerStatus = tsLocked;
-                     locked.Broadcast();
+                  continue;
+                  }
+          case tsLocked:
+               if (Status & FE_REINIT) {
+                  tunerStatus = tsSet;
+                  diseqcCommands = NULL;
+                  esyslog("ERROR: frontend %d was reinitialized", cardIndex);
+                  lastTimeoutReport = 0;
+                  continue;
+                  }
+               else if (Status & FE_HAS_LOCK) {
+                  if (LostLock) {
+                     esyslog("frontend %d regained lock on channel %d, tp %d", cardIndex, channel.Number(), channel.Transponder());
+                     LostLock = false;
                      }
+                  tunerStatus = tsLocked;
+                  locked.Broadcast();
+                  lastTimeoutReport = 0;
+                  }
+               else if (tunerStatus == tsLocked) {
+                  LostLock = true;
+                  esyslog("ERROR: frontend %d lost lock on channel %d, tp %d", cardIndex, channel.Number(), channel.Transponder());
+                  tunerStatus = tsTuned;
+                  Timer.Set(lockTimeout);
+                  lastTimeoutReport = 0;
                   continue;
                   }
           }
@@ -471,13 +503,21 @@
 
 int cDvbDevice::ProvidesCa(const cChannel *Channel) const
 {
-  if (Channel->Ca() >= 0x0100 && ciHandler) {
-     unsigned short ids[MAXCAIDS + 1];
-     for (int i = 0; i <= MAXCAIDS; i++) // '<=' copies the terminating 0!
-         ids[i] = Channel->Ca(i);
-     return ciHandler->ProvidesCa(ids);
+  int NumCams = 0;
+  if (ciHandler) {
+     NumCams = ciHandler->NumCams();
+     if (Channel->Ca() >= CA_ENCRYPTED_MIN) {
+        unsigned short ids[MAXCAIDS + 1];
+        for (int i = 0; i <= MAXCAIDS; i++) // '<=' copies the terminating 0!
+            ids[i] = Channel->Ca(i);
+        if (ciHandler->ProvidesCa(ids))
+           return NumCams + 1;
+        }
      }
-  return cDevice::ProvidesCa(Channel);
+  int result = cDevice::ProvidesCa(Channel);
+  if (result > 0)
+     result += NumCams;
+  return result;
 }
 
 cSpuDecoder *cDvbDevice::GetSpuDecoder(void)
@@ -487,103 +527,84 @@
   return spuDecoder;
 }
 
-bool cDvbDevice::GrabImage(const char *FileName, bool Jpeg, int Quality, int SizeX, int SizeY)
+uchar *cDvbDevice::GrabImage(int &Size, bool Jpeg, int Quality, int SizeX, int SizeY)
 {
   if (devVideoIndex < 0)
-     return false;
+     return NULL;
   char buffer[PATH_MAX];
   snprintf(buffer, sizeof(buffer), "%s%d", DEV_VIDEO, devVideoIndex);
   int videoDev = open(buffer, O_RDWR);
-  if (videoDev < 0)
-     LOG_ERROR_STR(buffer);
   if (videoDev >= 0) {
-     int result = 0;
+     uchar *result = NULL;
      struct video_mbuf mbuf;
-     result |= ioctl(videoDev, VIDIOCGMBUF, &mbuf);
-     if (result == 0) {
+     if (ioctl(videoDev, VIDIOCGMBUF, &mbuf) == 0) {
         int msize = mbuf.size;
         unsigned char *mem = (unsigned char *)mmap(0, msize, PROT_READ | PROT_WRITE, MAP_SHARED, videoDev, 0);
         if (mem && mem != (unsigned char *)-1) {
            // set up the size and RGB
            struct video_capability vc;
-           result |= ioctl(videoDev, VIDIOCGCAP, &vc);
-           struct video_mmap vm;
-           vm.frame = 0;
-           if ((SizeX > 0) && (SizeX <= vc.maxwidth) &&
-               (SizeY > 0) && (SizeY <= vc.maxheight)) {
-              vm.width = SizeX;
-              vm.height = SizeY;
-              }
-           else {
-              vm.width = vc.maxwidth;
-              vm.height = vc.maxheight;
-              }
-           vm.format = VIDEO_PALETTE_RGB24;
-           result |= ioctl(videoDev, VIDIOCMCAPTURE, &vm);
-           result |= ioctl(videoDev, VIDIOCSYNC, &vm.frame);
-           // make RGB out of BGR:
-           int memsize = vm.width * vm.height;
-           unsigned char *mem1 = mem;
-           for (int i = 0; i < memsize; i++) {
-               unsigned char tmp = mem1[2];
-               mem1[2] = mem1[0];
-               mem1[0] = tmp;
-               mem1 += 3;
-               }
-
-           if (Quality < 0)
-              Quality = 100;
-
-           isyslog("grabbing to %s (%s %d %d %d)", FileName, Jpeg ? "JPEG" : "PNM", Quality, vm.width, vm.height);
-           FILE *f = fopen(FileName, "wb");
-           if (f) {
-              if (Jpeg) {
-                 // write JPEG file:
-                 struct jpeg_compress_struct cinfo;
-                 struct jpeg_error_mgr jerr;
-                 cinfo.err = jpeg_std_error(&jerr);
-                 jpeg_create_compress(&cinfo);
-                 jpeg_stdio_dest(&cinfo, f);
-                 cinfo.image_width = vm.width;
-                 cinfo.image_height = vm.height;
-                 cinfo.input_components = 3;
-                 cinfo.in_color_space = JCS_RGB;
-
-                 jpeg_set_defaults(&cinfo);
-                 jpeg_set_quality(&cinfo, Quality, true);
-                 jpeg_start_compress(&cinfo, true);
-
-                 int rs = vm.width * 3;
-                 JSAMPROW rp[vm.height];
-                 for (int k = 0; k < vm.height; k++)
-                     rp[k] = &mem[rs * k];
-                 jpeg_write_scanlines(&cinfo, rp, vm.height);
-                 jpeg_finish_compress(&cinfo);
-                 jpeg_destroy_compress(&cinfo);
+           if (ioctl(videoDev, VIDIOCGCAP, &vc) == 0) {
+              struct video_mmap vm;
+              vm.frame = 0;
+              if ((SizeX > 0) && (SizeX <= vc.maxwidth) &&
+                  (SizeY > 0) && (SizeY <= vc.maxheight)) {
+                 vm.width = SizeX;
+                 vm.height = SizeY;
                  }
               else {
-                 // write PNM file:
-                 if (fprintf(f, "P6\n%d\n%d\n255\n", vm.width, vm.height) < 0 ||
-                     fwrite(mem, vm.width * vm.height * 3, 1, f) != 1) {
-                    LOG_ERROR_STR(FileName);
-                    result |= 1;
+                 vm.width = vc.maxwidth;
+                 vm.height = vc.maxheight;
+                 }
+              vm.format = VIDEO_PALETTE_RGB24;
+              if (ioctl(videoDev, VIDIOCMCAPTURE, &vm) == 0 && ioctl(videoDev, VIDIOCSYNC, &vm.frame) == 0) {
+                 // make RGB out of BGR:
+                 int memsize = vm.width * vm.height;
+                 unsigned char *mem1 = mem;
+                 for (int i = 0; i < memsize; i++) {
+                     unsigned char tmp = mem1[2];
+                     mem1[2] = mem1[0];
+                     mem1[0] = tmp;
+                     mem1 += 3;
+                     }
+
+                 if (Quality < 0)
+                    Quality = 100;
+
+                 isyslog("grabbing to %s %d %d %d", Jpeg ? "JPEG" : "PNM", Quality, vm.width, vm.height);
+                 if (Jpeg) {
+                    // convert to JPEG:
+                    result = RgbToJpeg(mem, vm.width, vm.height, Size, Quality);
+                    if (!result)
+                       esyslog("ERROR: failed to convert image to JPEG");
+                    }
+                 else {
+                    // convert to PNM:
+                    char buf[32];
+                    snprintf(buf, sizeof(buf), "P6\n%d\n%d\n255\n", vm.width, vm.height);
+                    int l = strlen(buf);
+                    int bytes = memsize * 3;
+                    Size = l + bytes;
+                    result = MALLOC(uchar, Size);
+                    if (result) {
+                       memcpy(result, buf, l);
+                       memcpy(result + l, mem, bytes);
+                       }
+                    else
+                       esyslog("ERROR: failed to convert image to PNM");
                     }
                  }
-              fclose(f);
-              }
-           else {
-              LOG_ERROR_STR(FileName);
-              result |= 1;
               }
            munmap(mem, msize);
            }
         else
-           result |= 1;
+           esyslog("ERROR: failed to memmap video device");
         }
      close(videoDev);
-     return result == 0;
+     return result;
      }
-  return false;
+  else
+     LOG_ERROR_STR(buffer);
+  return NULL;
 }
 
 void cDvbDevice::SetVideoDisplayFormat(eVideoDisplayFormat VideoDisplayFormat)
@@ -754,7 +775,7 @@
            if (Channel->Vpid() && !HasPid(Channel->Vpid()) || Channel->Apid(0) && !HasPid(Channel->Apid(0))) {
 #ifdef DO_MULTIPLE_RECORDINGS
 #ifndef DO_MULTIPLE_CA_CHANNELS
-              if (Ca() > CACONFBASE || Channel->Ca() > CACONFBASE)
+              if (Ca() >= CA_ENCRYPTED_MIN || Channel->Ca() >= CA_ENCRYPTED_MIN)
                  needsDetachReceivers = Ca() != Channel->Ca();
               else
 #endif
@@ -825,6 +846,11 @@
         esyslog("ERROR: failed to set PIDs for channel %d on device %d", Channel->Number(), CardIndex() + 1);
         return false;
         }
+     //XXX quick workaround for additional live audio PIDs:
+     if (ciHandler) {
+        ciHandler->SetPid(Channel->Apid(1), true);
+        ciHandler->SetPid(Channel->Dpid(0), true);
+        }
      if (IsPrimaryDevice())
         AddPid(Channel->Tpid(), ptTeletext);
      CHECK(ioctl(fd_audio, AUDIO_SET_MUTE, true)); // actually one would expect 'false' here, but according to Marco Schlüßler <marco@lordzodiac.de> this works
diff -ruN vdr-1.3.37/dvbdevice.h vdr-1.3.38/dvbdevice.h
--- vdr-1.3.37/dvbdevice.h	2005-11-11 15:51:38.000000000 +0100
+++ vdr-1.3.38/dvbdevice.h	2005-12-29 14:33:12.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.h 1.36 2005/11/11 14:51:38 kls Exp $
+ * $Id: dvbdevice.h 1.37 2005/12/29 13:33:12 kls Exp $
  */
 
 #ifndef __DVBDEVICE_H
@@ -85,7 +85,7 @@
   static int devVideoOffset;
   int devVideoIndex;
 public:
-  virtual bool GrabImage(const char *FileName, bool Jpeg = true, int Quality = -1, int SizeX = -1, int SizeY = -1);
+  virtual uchar *GrabImage(int &Size, bool Jpeg = true, int Quality = -1, int SizeX = -1, int SizeY = -1);
 
 // Video format facilities
 
diff -ruN vdr-1.3.37/dvbosd.c vdr-1.3.38/dvbosd.c
--- vdr-1.3.37/dvbosd.c	2005-05-22 12:57:45.000000000 +0200
+++ vdr-1.3.38/dvbosd.c	2005-12-30 16:41:54.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbosd.c 1.27 2005/05/22 10:57:45 kls Exp $
+ * $Id: dvbosd.c 1.29 2005/12/30 15:41:54 kls Exp $
  */
 
 #include "dvbosd.h"
@@ -39,7 +39,7 @@
   osdDev = OsdDev;
   shown = false;
   if (osdDev < 0)
-     esyslog("ERROR: illegal OSD device handle (%d)!", osdDev);
+     esyslog("ERROR: invalid OSD device handle (%d)!", osdDev);
   else {
      osdMem = MAXOSDMEMORY;
 #ifdef OSD_CAP_MEMSIZE
@@ -88,6 +88,8 @@
             return oeBppNotSupported;
          if ((Areas[i].Width() & (8 / Areas[i].bpp - 1)) != 0)
             return oeWrongAlignment;
+         if (Areas[i].Width() < 1 || Areas[i].Height() < 1 || Areas[i].Width() > 720 || Areas[i].Height() > 576)
+            return oeWrongAreaSize;
          TotalMemory += Areas[i].Width() * Areas[i].Height() / (8 / Areas[i].bpp);
          }
      if (TotalMemory > osdMem)
diff -ruN vdr-1.3.37/dvbplayer.c vdr-1.3.38/dvbplayer.c
--- vdr-1.3.37/dvbplayer.c	2005-10-31 13:33:48.000000000 +0100
+++ vdr-1.3.38/dvbplayer.c	2006-01-08 12:39:41.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbplayer.c 1.41 2005/10/31 12:33:48 kls Exp $
+ * $Id: dvbplayer.c 1.42 2006/01/08 11:39:41 kls Exp $
  */
 
 #include "dvbplayer.h"
@@ -621,7 +621,7 @@
      int Current, Total;
      GetIndex(Current, Total, true);
      int OldCurrent = Current;
-     // As GetNextIFrame() increments/decrements at least once, the 
+     // As GetNextIFrame() increments/decrements at least once, the
      // destination frame (= Current + Frames) must be adjusted by
      // -1/+1 respectively.
      Current = index->GetNextIFrame(Current + Frames + (Frames > 0 ? -1 : 1), Frames > 0);
diff -ruN vdr-1.3.37/dvbspu.c vdr-1.3.38/dvbspu.c
--- vdr-1.3.37/dvbspu.c	2005-11-05 13:08:15.000000000 +0100
+++ vdr-1.3.38/dvbspu.c	2006-01-08 12:39:46.000000000 +0100
@@ -8,16 +8,15 @@
  *
  * parts of this file are derived from the OMS program.
  *
- * $Id: dvbspu.c 1.17 2005/11/05 12:08:15 kls Exp $
+ * $Id: dvbspu.c 1.19 2006/01/08 11:39:46 kls Exp $
  */
 
+#include "dvbspu.h"
 #include <assert.h>
 #include <string.h>
 #include <inttypes.h>
 #include <math.h>
-
 #include "device.h"
-#include "dvbspu.h"
 
 /*
  * cDvbSpubitmap:
@@ -28,7 +27,7 @@
  * Inputs:
  *  - a SPU rle encoded image on creation, which will be decoded into
  *    the full screen indexed bitmap
- *  
+ *
  * Output:
  *  - a minimal sized cDvbSpuBitmap a given palette, the indexed bitmap
  *    will be scanned to get the smallest possible resulting bitmap considering
@@ -436,7 +435,7 @@
 
             prev_DCSQ_offset = DCSQ_offset;
             DCSQ_offset = spuU32(i);
-            DEBUG("offs = %d, DCSQ = %d, prev_DCSQ = %d\n", 
+            DEBUG("offs = %d, DCSQ = %d, prev_DCSQ = %d\n",
                            i, DCSQ_offset, prev_DCSQ_offset);
             i += 2;
 
diff -ruN vdr-1.3.37/dvbspu.h vdr-1.3.38/dvbspu.h
--- vdr-1.3.37/dvbspu.h	2005-11-05 13:08:47.000000000 +0100
+++ vdr-1.3.38/dvbspu.h	2006-01-05 11:18:31.000000000 +0100
@@ -8,16 +8,16 @@
  *
  * parts of this file are derived from the OMS program.
  *
- * $Id: dvbspu.h 1.10 2005/11/05 12:08:47 kls Exp $
+ * $Id: dvbspu.h 1.11 2006/01/05 10:18:31 kls Exp $
  */
 
 #ifndef __DVBSPU_H
 #define __DVBSPU_H
 
 #include <inttypes.h>
-
 #include "osd.h"
 #include "spu.h"
+#include "thread.h"
 
 typedef struct sDvbSpuPalDescr {
     uint8_t index;
diff -ruN vdr-1.3.37/eit.c vdr-1.3.38/eit.c
--- vdr-1.3.37/eit.c	2005-11-04 15:19:16.000000000 +0100
+++ vdr-1.3.38/eit.c	2005-12-26 12:50:09.000000000 +0100
@@ -8,7 +8,7 @@
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  * Adapted to 'libsi' for VDR 1.3.0 by Marcel Wiesweg <marcel.wiesweg@gmx.de>.
  *
- * $Id: eit.c 1.112 2005/11/04 14:19:16 kls Exp $
+ * $Id: eit.c 1.113 2005/12/26 11:50:09 kls Exp $
  */
 
 #include "eit.h"
@@ -43,6 +43,8 @@
 
   bool Empty = true;
   bool Modified = false;
+  time_t SegmentStart = 0;
+  time_t SegmentEnd = 0;
 
   SI::EIT::Event SiEitEvent;
   for (SI::Loop::Iterator it; eventLoop.getNext(SiEitEvent, it); ) {
@@ -50,6 +52,9 @@
       if (SiEitEvent.getStartTime() == 0 || SiEitEvent.getStartTime() > 0 && SiEitEvent.getDuration() == 0)
          continue;
       Empty = false;
+      if (!SegmentStart)
+         SegmentStart = SiEitEvent.getStartTime();
+      SegmentEnd = SiEitEvent.getStartTime() + SiEitEvent.getDuration();
       cEvent *newEvent = NULL;
       cEvent *rEvent = NULL;
       cEvent *pEvent = (cEvent *)pSchedule->GetEvent(SiEitEvent.getEventId(), SiEitEvent.getStartTime());
@@ -242,6 +247,7 @@
      pSchedule->SetPresentSeen();
   if (Modified) {
      pSchedule->Sort();
+     pSchedule->DropOutdated(SegmentStart, SegmentEnd, Tid, getVersionNumber());
      Schedules->SetModified(pSchedule);
      }
 }
diff -ruN vdr-1.3.37/eitscan.c vdr-1.3.38/eitscan.c
--- vdr-1.3.37/eitscan.c	2005-11-05 16:24:36.000000000 +0100
+++ vdr-1.3.38/eitscan.c	2006-01-07 15:10:17.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: eitscan.c 1.29 2005/11/05 15:24:36 kls Exp $
+ * $Id: eitscan.c 1.30 2006/01/07 14:10:17 kls Exp $
  */
 
 #include "eitscan.h"
@@ -147,7 +147,7 @@
                   for (cScanData *ScanData = scanList->First(); ScanData; ScanData = scanList->Next(ScanData)) {
                       const cChannel *Channel = ScanData->GetChannel();
                       if (Channel) {
-                         if (!Channel->Ca() || Channel->Ca() == Device->DeviceNumber() + 1 || Channel->Ca() >= 0x0100) {
+                         if (!Channel->Ca() || Channel->Ca() == Device->DeviceNumber() + 1 || Channel->Ca() >= CA_ENCRYPTED_MIN) {
                             if (Device->ProvidesTransponder(Channel)) {
                                if (!Device->Receiving()) {
                                   bool MaySwitchTransponder = Device->MaySwitchTransponder();
